unit EBDEFieldsEditor;

{
Author     : Guy Smith-Ferrier
Date       : February 2000
Description:
This unit contains TETableEditor, TEQueryEditor and TEStoredProcEditor which
are the Enhanced Fields Editors for TTable, TQuery and TStoredProc. They
inherit from classes in BDEReg2 (which contains further information).

}

interface

uses
  DSDesign, DsgnIntf, BDEReg2, DBReg, DB, DBTables, StdCtrls;

type
  TEBDEDesigner = class(TBDEDesigner)
  public
    function GetControlClass(Field: TField): string; override;
  end;

  TETableEditor = class(TTableEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  TEQueryEditor = class(TQueryEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  TEStoredProcEditor = class(TStoredProcEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  procedure Register;

implementation

uses
  EFECommon;

function TEBDEDesigner.GetControlClass(Field: TField): string;
begin
  Result:=EFEGetControlClass(Field);
  if Result='' then
    Result := inherited GetControlClass(Field)
end;

function TETableEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TEBDEDesigner
end;

function TEQueryEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TEBDEDesigner
end;

function TEStoredProcEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TEBDEDesigner
end;

procedure Register;
begin
  RegisterComponentEditor(TTable, TETableEditor);
  RegisterComponentEditor(TQuery, TEQueryEditor);
  RegisterComponentEditor(TStoredProc, TStoredProcEditor);
end;

end.
