unit ECDSFieldsEditor;
{
Author     : Guy Smith-Ferrier
Date       : February 2000
Description:
This unit contains TECDSDataSetEditor which is the Enhanced TClientDataSet
Fields Editor. It inherits from TClientDataSetEditor and TCDSDesigner which
are located in MidReg2 (which contains further information).
}

interface

uses
  EDSFieldsEditor, MidReg2, DBReg, DB, DSDesign, DsgnIntf;

type
  TECDSDataSetEditor = class(TClientDataSetEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  TECDSDesigner = class(TCDSDesigner)
  public
    function GetControlClass(Field: TField): string; override;
  end;

  procedure Register;

implementation

uses
  DBClient, EFECommon;

function TECDSDesigner.GetControlClass(Field: TField): string;
begin
  Result:=EFEGetControlClass(Field);
  if Result='' then
    Result := inherited GetControlClass(Field)
end;

function TECDSDataSetEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TECDSDesigner
end;

procedure Register;
begin
  RegisterComponentEditor(TClientDataSet, TECDSDataSetEditor);
end;

end.
