unit EDSFieldsEditor;

interface
{
Author     : Guy Smith-Ferrier
Date       : February 2000
Description:
This unit contains the Enhanced basic data set designer and the Enhanced dataset
editor. These classes are used by all dataset components which do not explicitly
set their own Field Editor. As such this means all InterBase Express components
and any custom datasets which inherit from TDataSet. 
}

uses
  DSDesign, DsgnIntf, DBReg, DB, StdCtrls;

type
  TEDSDesigner = class(TDSDesigner)
  public
    function GetControlClass(Field: TField): string; override;
  end;

  TEDataSetEditor = class(TDataSetEditor)
  protected
    function GetDSDesignerClass: TDSDesignerClass; override;
  end;

  procedure Register;

implementation

uses
  EFECommon;
  
function TEDSDesigner.GetControlClass(Field: TField): string;
begin
  Result:=EFEGetControlClass(Field);
  if Result='' then
    Result := inherited GetControlClass(Field)
end;

function TEDataSetEditor.GetDSDesignerClass: TDSDesignerClass;
begin
  Result := TEDSDesigner
end;

procedure Register;
begin
  RegisterComponentEditor(TDataSet, TEDataSetEditor);
end;

end.
